Automate installation of DXVK, D9VK + Wine/Wine Staging & update GPU drivers + PlayonLinux wineprefixes (Debian/Ubuntu/Mint/Arch Linux/Manjaro)
You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

395 lines
11 KiB

5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
  1. #!/bin/env bash
  2. # DXVK/Wine-Staging scripts dispatcher for various Linux distributions
  3. # Copyright (C) 2019 Pekka Helenius
  4. #
  5. # This program is free software: you can redistribute it and/or modify
  6. # it under the terms of the GNU General Public License as published by
  7. # the Free Software Foundation, either version 3 of the License, or
  8. # (at your option) any later version.
  9. #
  10. # This program is distributed in the hope that it will be useful,
  11. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  12. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  13. # GNU General Public License for more details.
  14. #
  15. # You should have received a copy of the GNU General Public License
  16. # along with this program. If not, see <https://www.gnu.org/licenses/>.
  17. ##############################################################################
  18. # Check if we're using bash or sh to run the script. If bash, OK.
  19. # If another one, ask user to run the script with bash.
  20. BASH_CHECK=$(ps | grep `echo $$` | awk '{ print $4 }')
  21. if [ $BASH_CHECK != "bash" ]; then
  22. echo "
  23. Please run this script using bash (/usr/bin/bash).
  24. "
  25. exit 1
  26. fi
  27. ###########################################################
  28. # Just a title & author for this script, used in initialization and help page
  29. SCRIPT_TITLE="\e[1mWine/Wine Staging & DXVK package builder & auto-installer\e[0m"
  30. SCRIPT_AUTHOR="Pekka Helenius (~Fincer), 2019"
  31. ########################################################
  32. # Should we freeze Git versions of these packages?
  33. # This is handy in some cases, if breakages occur
  34. # (although we actually compile an older version of a package)
  35. #
  36. # Define a commit hash to freeze to
  37. # Use keyword 'HEAD' if you want to use the latest git
  38. # version available
  39. # Do NOT leave these variable empty!
  40. git_commithash_dxvk=HEAD
  41. git_branch_dxvk=master
  42. git_commithash_wine=HEAD
  43. git_branch_wine=master
  44. # These apply only on Debian/Ubuntu/Mint
  45. git_commithash_meson=5d6dcf8850fcc5d552f55943b6aa3582754dedf8
  46. git_branch_meson=master
  47. git_commithash_glslang=HEAD
  48. git_branch_glslang=master
  49. ###########################################################
  50. # Allow interruption of the script at any time (Ctrl + C)
  51. trap "exit" INT
  52. ###########################################################
  53. COMMANDS=(
  54. curl
  55. date
  56. df
  57. find
  58. git
  59. grep
  60. groups
  61. nproc
  62. patch
  63. readlink
  64. sudo
  65. tar
  66. uname
  67. wc
  68. wget
  69. )
  70. SUDO_GROUPS=(
  71. sudo
  72. wheel
  73. )
  74. function checkCommands() {
  75. if [[ $(which --help 2>/dev/null) ]] && [[ $(echo --help 2>/dev/null) ]]; then
  76. local a=0
  77. for command in ${@}; do
  78. if [[ ! $(which $command 2>/dev/null) ]]; then
  79. local COMMANDS_NOTFOUND[$a]=${command}
  80. let a++
  81. fi
  82. done
  83. if [[ -n $COMMANDS_NOTFOUND ]]; then
  84. echo -e "\nError! The following commands could not be found: ${COMMANDS_NOTFOUND[*]}\nAborting\n"
  85. exit 1
  86. fi
  87. else
  88. exit 1
  89. fi
  90. }
  91. checkCommands "${COMMANDS[*]}"
  92. ###########################################################
  93. # http://wiki.bash-hackers.org/snipplets/print_horizontal_line#a_line_across_the_entire_width_of_the_terminal
  94. function INFO_SEP() { printf '%*s\n' "${COLUMNS:-$(tput cols)}" '' | tr ' ' - ; }
  95. ###########################################################
  96. if [[ $(uname -a | grep -c x86_64) -eq 0 ]]; then
  97. echo "This script supports 64-bit architectures only."
  98. exit 1
  99. fi
  100. if [[ $(groups | grep -cE $(echo ${SUDO_GROUPS[*]} | sed 's/ /|/g')) -eq 0 ]]; then
  101. echo "You must belong to a sudo group (checked groups: ${SUDO_GROUPS[*]})."
  102. exit 1
  103. fi
  104. unset sudogrp
  105. if [[ $UID -eq 0 ]]; then
  106. echo "Run as a regular user."
  107. exit 1
  108. fi
  109. ###########################################################
  110. # User-passed arguments for the script
  111. # We check the values of this array
  112. # and pass them to the subscripts if supported
  113. i=0
  114. for arg in ${@}; do
  115. case ${arg} in
  116. --no-staging)
  117. # Do not build Wine staging version, just Wine
  118. ;;
  119. --no-install)
  120. # Just build, do not install DXVK or Wine-Staging
  121. # Note that some version of Wine is required for DXVK compilation, though!
  122. ;;
  123. --no-wine)
  124. # Skip Wine build & installation process all together
  125. NO_WINE=
  126. ;;
  127. --no-dxvk)
  128. # Skip DXVK build & installation process all together
  129. NO_DXVK=
  130. ;;
  131. --no-pol)
  132. # Skip PlayOnLinux Wine prefixes update process
  133. ;;
  134. *)
  135. echo -e "\n\
  136. \
  137. ${SCRIPT_TITLE} by ${SCRIPT_AUTHOR}\n\n\
  138. Usage:\n\nbash updatewine.sh\n\nArguments:\n\n\
  139. --no-install\tDo not install Wine or DXVK. Just compile them. Wine, meson & glslang must be installed for DXVK compilation.\n\
  140. --no-dxvk\tDo not compile or install DXVK\n\
  141. --no-pol\tDo not update PlayOnLinux Wine prefixes\n\n\
  142. --no-staging\tCompile Wine instead of Wine Staging\n\
  143. --no-wine\tDo not compile or install Wine/Wine Staging\n\n\
  144. Compiled packages are installed by default, unless '--no-install' argument is given.\n\
  145. If '--no-install' argument is given, the script doesn't check or update your PlayOnLinux Wine prefixes.\n"
  146. exit 0
  147. ;;
  148. esac
  149. args[$i]="${arg}"
  150. let i++
  151. done
  152. ###########################################################
  153. # Date timestamp and random number identifier for compiled
  154. # DXVK & Wine Staging builds
  155. # This variable is known as 'datedir' in other script files
  156. datesuffix=$(echo $(date '+%Y-%m-%d-%H%M%S'))
  157. ###########################################################
  158. # Add git commit hash overrides to argument list
  159. # Pass them to subscripts, as well.
  160. githash_overrides=(
  161. "${git_commithash_dxvk}"
  162. "${git_commithash_glslang}"
  163. "${git_commithash_meson}"
  164. "${git_commithash_wine}"
  165. )
  166. # Add git branches to argument list
  167. # Pass them to subscripts, as well.
  168. gitbranch_overrides=(
  169. "${git_branch_dxvk}"
  170. "${git_branch_glslang}"
  171. "${git_branch_meson}"
  172. "${git_branch_wine}"
  173. )
  174. #############################
  175. # Commit syntax validity check
  176. for githash in ${githash_overrides[@]}; do
  177. if [[ ! $(printf ${githash} | wc -c) -eq 40 ]] && \
  178. [[ ! ${githash} == HEAD ]]; then
  179. echo -e "\nError: badly formatted commit hash '${githash}' in the script file 'updatewine.sh'. Aborting\n"
  180. exit 1
  181. fi
  182. done
  183. ###########################################################
  184. params=(${datesuffix} ${githash_overrides[@]} ${gitbranch_overrides[@]} ${args[@]})
  185. ###########################################################
  186. # General function for question responses
  187. function questionresponse() {
  188. local response=${1}
  189. read -r -p "" response
  190. if [[ $(echo $response | sed 's/ //g') =~ ^([yY][eE][sS]|[yY])$ ]]; then
  191. echo ""
  192. return 0
  193. else
  194. return 1
  195. fi
  196. }
  197. ###########################################################
  198. function reqsCheck() {
  199. local AVAIL_SPACE=$(df -h -B MB --output=avail . | sed '1d; s/[A-Z]*//g')
  200. local REC_SPACE=8000
  201. local MSG_SPACE="\e[1mWARNING:\e[0m Not sufficient storage space\n\nYou will possibly run out of space while compiling software.\n\
  202. The script strongly recommends ~\e[1m$((${REC_SPACE} / 1000)) GB\e[0m at least to compile software successfully but you have only\n\
  203. \e[1m${AVAIL_SPACE} MB\e[0m left on the filesystem the script is currently placed at.\n\n\
  204. Be aware that the script process may fail because of this, especially while compiling Wine Staging.\n\n\
  205. Do you really want to continue? [Y/n]"
  206. local AVAIL_RAM=$(( $(grep -oP "(?<=^MemFree:).*[0-9]" /proc/meminfo | sed 's/ //g') / 1024 ))
  207. local REC_RAM=4096
  208. local MSG_RAM="\e[1mWARNING:\e[0m Not sufficient RAM available\n\nCompilation processes will likely fail.\n\
  209. The script strongly recommends ~\e[1m${REC_RAM} MB\e[0m at least to compile software successfully but you have only\n\
  210. \e[1m${AVAIL_RAM} MB\e[0m left on the computer the script is currently placed at.\n\n\
  211. Be aware that the script process may fail because of this, especially while compiling DXVK.\n\n\
  212. Do you really want to continue? [Y/n]"
  213. function reqs_property() {
  214. local avail_prop="${1}"
  215. local req_prop="${2}"
  216. local req_message="${3}"
  217. local req_installtargets="${4}"
  218. local i=0
  219. for req_installtarget in ${req_installtargets}; do
  220. req_targetconditions[$i]=$(echo "[[ ! -v ${req_installtarget} ]] ||")
  221. let i++
  222. done
  223. local req_targetconditions=($(echo ${req_targetconditions[@]} | sed 's/\(.*\) ||/\1 /'))
  224. local fullcondition="[[ "${avail_prop}" -lt "${req_prop}" ]] && ($(echo ${req_targetconditions[@]}))"
  225. if $(eval ${fullcondition}); then
  226. INFO_SEP
  227. echo -e "${req_message}"
  228. questionresponse
  229. if [[ $? -ne 0 ]]; then
  230. echo -e "Cancelling.\n"
  231. exit 1
  232. fi
  233. unset avail_prop req_prop req_installtarget req_targetconditions fullcondition
  234. fi
  235. }
  236. reqs_property "${AVAIL_SPACE}" "${REC_SPACE}" "${MSG_SPACE}" "NO_WINE"
  237. reqs_property "${AVAIL_RAM}" "${REC_RAM}" "${MSG_RAM}" "NO_DXVK"
  238. }
  239. ###########################################################
  240. function sudoQuestion() {
  241. sudo -k
  242. echo -e "\e[1mINFO:\e[0m sudo password required\n\nThis script requires elevated permissions for package updates & installations. Please provide your sudo password for these script commands. Sudo permissions are not used for any other purposes.\n"
  243. sudo -v
  244. if [[ $? -ne 0 ]]; then
  245. echo -e "Invalid sudo password.\n"
  246. exit 1
  247. fi
  248. # PID of the current main process
  249. PIDOF=$$
  250. # Run sudo timestamp update on the background and continue the script execution
  251. # Refresh sudo timestamp while the main process is running
  252. function sudo_refresh() {
  253. while [[ $(printf $(ps ax -o pid --no-headers | grep -o ${PIDOF} &> /dev/null)$?) -eq 0 ]]; do
  254. sudo -nv && sleep 2
  255. done
  256. }
  257. sudo_refresh &
  258. }
  259. ###########################################################
  260. function checkInternet() {
  261. if [[ $(echo $(wget --delete-after -q -T 5 github.com -o -)$?) -ne 0 ]]; then
  262. echo -e "\nDNS name resolution failed (GitHub). Please check your network connection settings and try again.\n"
  263. exit 1
  264. fi
  265. rm -f ./index.html.tmp
  266. }
  267. checkInternet
  268. ###########################################################
  269. # Only Debian & Arch based Linux distributions are currently supported
  270. function determineDistroFamily() {
  271. # These are default package managers used by the supported Linux distributions
  272. pkgmgrs=('dpkg' 'pacman')
  273. for pkgmgr in ${pkgmgrs[@]}; do
  274. if [[ $(printf $(which ${pkgmgr} &> /dev/null)$?) -eq 0 ]]; then
  275. pkgmgr_valid=${pkgmgr}
  276. fi
  277. done
  278. case ${pkgmgr_valid} in
  279. dpkg)
  280. distro="debian"
  281. ;;
  282. pacman)
  283. distro="arch"
  284. ;;
  285. default|*)
  286. echo -e "Your Linux distribution is not supported. Aborting.\n"
  287. exit 1
  288. ;;
  289. esac
  290. }
  291. if [[ ! -v NO_WINE ]] || [[ ! -v NO_DXVK ]]; then
  292. echo -e "\n${SCRIPT_TITLE}\n\nBuild identifier:\t${datesuffix}\n"
  293. else
  294. echo ""
  295. fi
  296. if [[ -n ${args[*]} ]]; then
  297. echo -e "Using arguments:\t${args[*]}\n"
  298. fi
  299. determineDistroFamily
  300. INFO_SEP
  301. echo -e "\e[1mNOTE: \e[0mDXVK requires very latest Nvidia/AMD drivers to work.\nMake sure these drivers are available on your Linux distribution.\n\
  302. This script comes with GPU driver installation scripts for Debian-based Linux distributions.\n"
  303. INFO_SEP
  304. if [[ ! -v NO_WINE ]] || [[ ! -v NO_DXVK ]]; then
  305. reqsCheck
  306. sudoQuestion
  307. echo ""
  308. fi
  309. bash -c "cd ${distro} && bash ./updatewine_${distro}.sh ${params[*]}"